<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
        v-if="outInData.verifyStatus==2"
        >通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="storemanApprove"
        v-if="
          ['storemanApprove'].includes(taskDefinitionKey) &&
          activeComp == 'main'&&[0,3].includes(outInData.verifyStatus)
        "
        >申请出库
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="!['starter'].includes(taskDefinitionKey)&&outInData.verifyStatus!=1"
        >驳回
      </el-button>
      <el-dropdown @command="(command) => handleCommand(command)" style="margin-left: 30px;">
        <span class="el-dropdown-link">更多<i class="el-icon-arrow-down el-icon--right"></i></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>

      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
  </el-col>
</template>

<script>
  import {
    UpdateReturnInformation,
    getWarehouseListByIds,
    approve,
    saleReturnProcessCancel,
  } from '@/api/bpm/components/saleManage/saleorder';
  import { approveTaskWithVariables } from '@/api/bpm/task';
  import { listAllUserBind } from '@/api/system/organization';

  // 流程实例的详情页，可用于审批
  export default {
    name: '',
    components: {
      //   Parser
    },
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        form: {
          technicianId: '',
          reason: ''
        },
        userOptions: [],
        activeComp:'',
        outInData:{verifyStatus:2},
      };
    },
    async created() {
      this.userOptions = [];
      listAllUserBind().then((data) => {
        this.userOptions.push(...data);
      });
      if (this.taskDefinitionKey == 'storemanApprove') {
        let data = await getReturnSaleOrderrecordDetail(this.businessId);
        try {
          this.outInData = await getOutInBySourceBizNo(data.orderNo);
        } catch (error) {}
          this.outInData.verifyStatus=0
      }
    },
    methods: {
      /** 处理转办审批人 */
      handleUpdateAssignee() {
        this.$emit('handleUpdateAssignee');
      },
      /** 退回 */
      handleBackList() {
        this.$emit('handleBackList');
      },
      async storemanApprove() {
        this.$emit('submit');
      },
      async handleAudit(status) {
        let returnType = '';
        //发起人补充
        if (this.taskDefinitionKey === 'starter') {
          let arr = await this.getTableValue();
          if (!arr) {
            return;
          }
          let data = await UpdateReturnInformation(arr);
          if (data.code != '0') {
            return;
          }
        }

        if (this.taskDefinitionKey === 'QCLeader') {
          let arr = await this.getTableValue();
          if (!arr) {
            return;
          }
          let data = await UpdateReturnInformation(arr);
          if (data.code != '0') {
            return;
          }
          returnType = arr.type;
        }
        if (this.taskDefinitionKey === 'produceLeader') {
          let arr = await this.getTableValue();
          if (!arr) {
            return;
          }
          let data = await UpdateReturnInformation(arr);
          if (data.code != '0') {
            return;
          }

        }
        this.approveTaskWithVariables(status, returnType);
      },
      activeCompChange(activeComp) {
        this.activeComp = activeComp;
      },
      async approveTaskWithVariables(status, returnType) {
        approve({
          id: this.taskId,
          reason: this.form.reason,
          operateType: status == 0 ? 2 : 1,
          returnType
        }).then((res) => {
          if (res.code != '-1') {
            this.$emit('handleAudit', {
              status,
              title: status === 0 ? '驳回' : ''
            });
          }
        });
      },

      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      },

      //更多
      handleCommand(command) {
        if (command === 'cancel') {
          this.$confirm("是否确认作废？", {
            type: 'warning',
            cancelButtonText: '取消',
            confirmButtonText: '确定'
          }).then(() => {
            saleReturnProcessCancel({
              id: this.taskId,
              reason: this.form.reason,
              businessId: this.businessId,
            }).then(() => {
              this.$emit('handleClose');
            }).catch(() => {
              this.$message.error("流程作废失败");
            });
          }).catch(() => {});
        }
      },

    }
  };
</script>

<style lang="scss"></style>
